
;ACHTUNG:        
;Bei 1875 zeile bei ein + aus zeitschleife in 0,5sec gendert //// war mal D'20' / also 2sec vor und nach Messung
        
;und einstellbereich geaendert:
;alter einstellbereich -40C bis 110C
;neuer einstellbereich -52C bis 122C
;minus zahlen auf zeile 841 und 1137
;positiv zahlen auf zeile 909 und 1018        
        
;****************************************************************************************
;*                           TEMPERATUR-REGLER                                          *
;*                           =================                                          *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;* PORT-PIN-ZUORDNUNG:                                                                  *
;* RA0 -EINGANG ABWAERTS TEMPERATUR HOHE                                                *
;* RA1 -EINGANG AUFWAERTS TEMPERATUR HOHE                                               *
;* RA2 -AUSGANG DATEN/BEFEHL LCD-MODUL                                                  *
;* RA3 -AUSGANG ENABLE LCD-MODUL                                                        *
;* RA4 -EINGANG DS18S20 TEMP-FHLER                                                     *
;* RA5 -EINGANG UNBENUTZT                                                               *
;* RA6 =OZS2 16MHZ QUARZ                                                                *
;* RA7 =OZS1 16MHZ QUARZ                                                                *
;*                                                                                      *
;* RB0 -EINGANG BEI ON KHLEN BEI OFF HEIZEN                                            *
;* RB1 -EINGANG AUFWAERTS TEMPERATUR NIEDRIGE                                           *
;* RB2 -EINGANG ABWAERTS TEMPERATUR NIEDRIGE                                            *
;* RB3 -AUSGANG HIGH-AKTIV NPN-TRANSISTOR RELAIS                                        *
;* RB4 -AUSGANG LCD-MODUL   ALLES DATENBUS 4-BIT                                        *
;* RB5 -AUSGANG LCD-MODUL                                                               *
;* RB6 -AUSGANG LCD-MODUL                                                               *
;* RB7 -AUSGANG LCD-MODUL                                                               *
;*                                                                                      *
;* RA5 GEHT NUR ALS EINGANG                                                             *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC16F628A                                                 *
;* ALS OSZILLATOR WURDE EIN QUARZ MIT 16,00MHZ GENOMMEN.(T=0.0625SEC ALSO DIE TAKTZEIT)*
;*                                   EIN BEFEHL HAT MEIST 4 TAKTE SIND 0,250SEC        *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                           BEGINN: 12.03.15                                           *
;*                           ENDE  : 31.03.15                                           *
;*                         GETESTET: 31.03.15                                           *
;****************************************************************************************

        LIST    P=16F628A       
        TITLE   "TEMP-REGLER"

        ERRORLEVEL -302
        INCLUDE <P16F628A.INC>

__CONFIG   _HS_OSC & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _LVP_OFF & _DATA_CP_OFF & _CP_OFF

;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


HELP1                   EQU     0X22    ;HILFSZELLE
HELP2                   EQU     0X23    ;HILFSZELLE
BIT                     EQU     0X24    ;HILFSZELLE FR DIE LCD-BCD-ANZEIGE 4-BIT 
MERK                    EQU     0X25    ;HILFSZELLE FR DIE LCD-BCD-ANZEIGE 4-BIT 
TEMP_L                  EQU     0X26    ;TEMPERATUR-BYTE
TEMP_H                  EQU     0X27    ;TEMPERATUR-BYTE
;---
ANZ_L                   EQU     0X28       ;HILFSZELLE FR DIE LCD-BCD-ANZEIGE
ANZ_H                   EQU     0X29       ;HILFSZELLE FR DIE LCD-BCD-ANZEIGE
VER                     EQU     0X2A       ;HILFSZELLE FR DIE LCD-BCD-ANZEIGE
MINUS                   EQU     0X2B       ;HILFSZELLE FR MINUS-ZEICHEN
TEM                     EQU     0X2C       ;HILFSZELLE FR DIE LCD-BCD-ANZEIGE
ZAE                     EQU     0X2D       ;HILFSZELLE FR DIE LCD-BCD-ANZEIGE
MERKE                   EQU     0X2E       ;HILFSZELLE FR DIE LCD-BCD-ANZEIGE
;---
IA                      EQU     0X2F    ;HILFSZELLE MEHRERE TEMPERATUREN BIT0=0 IST-TEMPERATUR / BIT0=1 + BIT1=0 NIEDRIGE TEMP. / BIT0=1 BIT1=1 HOHE TEMP
;---
TEMPN_L                 EQU     0X30    ;TEMPERATUR-BYTE NIEDRIGE TEMP ZUM STELLEN
TEMPN_H                 EQU     0X31    ;TEMPERATUR-BYTE 
TEMPH_L                 EQU     0X32    ;TEMPERATUR-BYTE HOHE TEMP ZUM STELLEN
TEMPH_H                 EQU     0X33    ;TEMPERATUR-BYTE
ADR                     EQU     0X34    ;EEPROMADRESSE BEIM SPEICHERN
;---
MERK1                   EQU     0X35    ;HILFSZELLE STELLEN
ZAE1                    EQU     0X36    ;HILFSZELLE STELLEN
ZAE2                    EQU     0X37    ;HILFSZELLE STELLEN
;---
MOD                     EQU     0X38    ;MODUS HEIZEN ODER KHLEN BIT0 = 0 KHLEN   / BEI 1 HEIZEN
ZUSTAND                 EQU     0X39    ;ZUSTAND BEIM RELAIS-SCHALTEN
TEMPN_MERK              EQU     0X3A    ;MERKER DER TEMPERATUR
TEMPH_MERK              EQU     0X3B    ;MERKER DER TEMPERATUR

NO_SENSOR               EQU     0X3C    ;BEI KEIN SENSOR BIT0 AUF HIGH ---BEI BIT0 IST HIGH SENSOR-FEHLT  
                                        ;---BEI BIT7 IST HIGH  RESETET NUR BEIM AUSSCHALTEN MIT AUS
                                        ;---BEI BIT3 FLIP / FLOP

;ZAEHLER                 EQU     0X3D    ;RESET-ZHLER 5-EINZYKLEN ZHLEN

;--------------------------- VARIABLEN -------------------------------------
BIT7                    EQU     7       ; BIT 7
BIT6                    EQU     6       ; BIT 6
BIT5                    EQU     5       ; BIT 5
BIT4                    EQU     4       ; BIT 4
BIT3                    EQU     3       ; BIT 3 
BIT2                    EQU     2       ; BIT 2
BIT1                    EQU     1       ; BIT 1 
BIT0                    EQU     0       ; BIT 0

;======================= FUER LCD-MODUL ===========================
RS                      EQU     2       ; PORTA BIT2 UMSCHALTEN BEFEHL/DATEN      BEI WRITE DATEN IST ES HIGH
EN                      EQU     3       ; PORTA BIT3 ENABLE FALLENDE FLANKE
;======================= FUER TEMP-FHLER =========================
TXRX                    EQU     4       ; PORTA BIT4 TEMPERATUR-FHLER DS18S20

 

;======================= FUER TASTER EINGANG ======================
AUF_H                   EQU     1       ; PORTA BIT1 AUFWRTS STELLEN HOHE TEMP
AB_H                    EQU     0       ; PORTA BIT0 ABWRTS STELLEN
;======================= FUER EIN/AUSGNGE ========================
HZ                      EQU     0       ; EINGANG PORTB BIT0 SCHALTER HEIZEN ODER KHLEN
AUF_L                   EQU     1       ; PORTB BIT1 AUFWRTS STELLEN NIEDRIGE TEMP
AB_L                    EQU     2       ; PORTB BIT2 ABWRTS STELLEN
NPN                     EQU     3       ; AUSGANG PORTB BIT3 RELAIS MIT NPN-TRANSISTOR

;------------------------- MACROS -----------------------------------------

BANK0           MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                BCF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK1           MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                BSF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK2           MACRO                   ;MACRO TO SELECT DATA RAM BANK 2
                BCF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

BANK3           MACRO                   ;MACRO TO SELECT DATA RAM BANK 3
                BSF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM


TXRX_OUTPUT     MACRO
                BSF     STATUS,RP0              ;T=4    ;BANK1-UMSCHALTUNG
                BCF     TRISA, TXRX             ;T=4    ;AM PORTA --> RA4 ALS AUSGANG
                BCF     STATUS,RP0              ;T=4    ;BANK0-UMSCHALTUNG
                BCF     PORTA, TXRX             ;T=4
                ENDM                            ;GES.: 1SEC


TXRX_INPUT      MACRO
                BSF     STATUS,RP0              ;T=4    ;BANK1-UMSCHALTUNG
                BSF     TRISA, TXRX             ;T=4    ;AM PORTA --> RA4 ALS EINGANG
                BCF     STATUS,RP0              ;T=4    ;BANK0-UMSCHALTUNG
                ENDM                            ;GES.: 1SEC

 
;-----------------------------------------------------------------------------
;SPEICHERANFANG BZW. BEGINN

                ORG 0X0000
                GOTO MAIN               ; SPRUNG ZUM HAUPTPROGRAMM
                ORG 0X0004
                RETFIE                  ; BEI EINEM INTERRUPT SOFORT EIN RETURN

                ORG 0X0010

;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              01.02.11                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN            CLRF    PORTA                           
                CLRF    PORTB

                CLRF    NO_SENSOR               ;BIT0 + BIT3 AUF FLIP / FLOP

                MOVLW   0X07                    ;COMPARATORS ALLE AUS VOM PORT A
                MOVWF   CMCON
                BANK1
                MOVLW   B'11110011'             ;INIT INPUT/OUTPUT AM PORTA --> BEI 0 AUSGAENGE -->RA2+3 AUSGANG SONST ALLES EINGANG
                MOVWF   TRISA
                MOVLW   B'00000111'             ;INIT INPUT/OUTPUT AM PORTB --> BEI 0 AUSGAENGE -->RB3 BIS RB7 AUSGNGE --DATENBUS FR ANZEIGE + RELAIS-AUSGANG
                MOVWF   TRISB

;INIT TIMER 0 
                MOVLW   B'10000111'             ;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG      
                BANK0

;INIT TIMER1
                MOVLW   0X30                  ;PRESCALE1:8 / SYSTEMCLOCK T/4 ==>1/32
                MOVWF   T1CON               

;50MSEC ZEITSCHLEIFE
                MOVLW   D'50'                 ;ZEITSCHLEIFE LADEN IN W MIT DEZIMAL 50 ALSO---> 50*1MSEC=50MSEC
                CALL    ZS1MS                 ;ZEITSCHLEIFE ABARBEITEN

;INITIALISIERUNG DOT-MATRIX-LCD
                MOVLW   H'28'                 ;FUNCTION SET  4-BIT-LAENGE, 2-ZEILIG, 5X7FONT
                CALL    BEFEHL

                MOVLW   H'0C'                 ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
                CALL    BEFEHL

                MOVLW   H'01'                 ;CLEAR DISPLAY
                CALL    BEFEHL

;5MSEC ZEITSCHLEIFE
                MOVLW   D'5'                 ;ZEITSCHLEIFE LADEN IN W MIT DEZIMAL 5 ALSO---> 5*1MSEC=5MSEC
                CALL    ZS1MS                ;ZEITSCHLEIFE ABARBEITEN

;---------------INITIALISIERUNG--ZU--ENDE-----------------------

                BCF     PORTB, NPN ;CALL    AUS                 ;KEIN RELAIS IST ANGEZOGEN / 

;ZUSTAND MERKER AUF RELAIS AUS  SETZEN
                CLRF    ZUSTAND
;------------

            CALL    PRINZIP             ;TEXT AUF LCD

            BTFSS   PORTB, HZ           ;HEIZEN ODER KHLEN ABFRAGE
            GOTO    ANF1
            CALL    HEIZ                ;TEXT AUF LCD-ANZEIGE
            BSF     MOD, BIT0           ;MODUS HEIZEN MERKEN
            GOTO    ANF2

ANF1        CALL    KUEL                ;TEXT AUF LCD-ANZEIGE 
            BCF     MOD, BIT0           ;MODUS KHLEN MERKEN

;2SEC ZEITSCHLEIFE
ANF2        MOVLW   D'20'               ;ZEITSCHLEIFE LADEN IN W MIT DEZIMAL 20 ALSO---> 20*100MSEC=2000MSEC=2SEC
            CALL    ZS100MS

            CALL    IS                      ;TEXT AUF LCD
            CALL    GR                      ;TEXT AUF LCD
            CALL    LE

;EEPROM AUSLESEN / OB SCHON BESCHRIEBEN ODER 1-TER START ?
            MOVLW   H'04'
            CALL    E_READ
            MOVWF   MERK

            MOVLW   0XFF
            SUBWF   MERK, W
            BTFSC   STATUS, Z
            GOTO    ANFF1

;ALTE ABGESPEICHERTE TEMPERATUREINSTELLUNG LADEN UND ANZEIGEN
            MOVLW   H'00'
            CALL    E_READ
            MOVWF   TEMP_H
            MOVWF   TEMPH_H

            MOVLW   H'01'
            CALL    E_READ
            MOVWF   TEMP_L
            MOVWF   TEMPH_L
            BSF     IA, BIT0                ;AN WELCHE STELLE ANGEZEIGT WIRD EINSTELLEN
            BSF     IA, BIT1
            CALL    BCD_ANZEIGE             ;HEX ZU BCD UMRECHNEN UND ANZEIGE

            MOVLW   H'02'
            CALL    E_READ
            MOVWF   TEMP_H
            MOVWF   TEMPN_H

            MOVLW   H'03'
            CALL    E_READ
            MOVWF   TEMP_L
            MOVWF   TEMPN_L
            BSF     IA, BIT0                ;AN WELCHE STELLE ANGEZEIGT WIRD EINSTELLEN
            BCF     IA, BIT1
            CALL    BCD_ANZEIGE             ;HEX ZU BCD UMRECHNEN UND ANZEIGE
            GOTO    ANF3

;WEIL 1-TER START ERST MAL 1-TE WERTE EINTRAGEN+SPEICHERN / DAMIT KEIN UNSINN DARGESTELLT WIRD
ANFF1       CALL    SPEI_NEU

;---------------------------------------------------------------------------------------------
;ABFRAGE STELLEN DER TEMPERATUR-SCHALTWERTE
ANF3                BTFSS   NO_SENSOR, BIT0
                    GOTO    AANFF3
                    MOVLW   D'10'
                    CALL    ZS100MS

AANFF3              BTFSC   NO_SENSOR, BIT7 ;RESET-ABFRAGE
                    GOTO    MAIN

                    MOVLW   D'16'      ;SIND 125MSEC * 16 = 2SEC
                    MOVWF   ZAE1
                    GOTO    TA4
;ZEITSCHLEIFE VON 2SEC REIN, MAN MUSS BEIDE TASTER SO LANGE DRCKEN BIS ERST GESTELLT WIRD

TA3                 CALL    I_ZS125MS
                    
TA1                 BTFSC   PIR1, TMR1IF
                    GOTO    TA2

TA4                 BTFSC   PORTA, AUF_H
                    GOTO    ANF4
                    BTFSC   PORTA, AB_H
                    GOTO    ANF4
                    GOTO    TA1

TA2                 DECFSZ  ZAE1, F
                    GOTO    TA3
                    BCF     T1CON, TMR1ON       ;STOP TIMER1
                    CALL    ST                  ;ANZEIGE MIT "ST" WIE STELLEN

;ZUSTAND MERKER AUF RELAIS AUS  SETZEN
                    CLRF    ZUSTAND
                    ;BCF     PORTB, NPN           ;CALL    AUS                 ;RELAIS AUS

;---------------------------------------------------------------------------------------------
;ZEITSCHLEIFE FR BEIDE TASTER LOSLASSEN 1,5SEC LANG /// DANN ERST STELLEN WEGEN INDUKTION
TX0                 MOVLW   D'2'     ;JETZT !!!!!!!!!! FUER NUR 0,25SEC LOSGELASSEN  /// VORHER ;D'12'      ;SIND 125MSEC * 12 = 1,5SEC
                    MOVWF   ZAE1

TX3                 CALL    I_ZS125MS
                    
TX2                 BTFSS   PORTA, AUF_H
                    GOTO    TX0
                    BTFSS   PORTA, AB_H
                    GOTO    TX0
                    BTFSS   PIR1, TMR1IF
                    GOTO    TX2
                    DECFSZ  ZAE1, F
                    GOTO    TX3

                    BCF     T1CON, TMR1ON       ;STOP TIMER1
                    BCF     PORTB, NPN          ;CALL    AUS                 ;RELAIS AUS

;---------------------------------------------------------------------------------------------

                    CALL    AUFAB               ;JETZT KANN MAN "10SEC LANG" STELLEN STELLEN


;---- GEHT LOS --- MIT TEMPERATUR MESSEN
ANF4        BCF     NO_SENSOR, BIT0         ;KEIN SENSOR ZURCK SETZEN
            CALL    RESE
            BTFSC   NO_SENSOR, BIT0
            GOTO    MAIN

            MOVLW   0XCC                    ;ROM BRAUCHT JETZT NICHT GESENDET WERDEN
            CALL    TX
            MOVLW   0X44                    ;AUFFORDERUNG ZUR TEMPERATUR-MESSUNG IM DS18S20
            CALL    TX

;----------------------------------------------
;1SEC ZEITSCHLEIFE MIT ABFRAGE TASTER FR DAS STELLEN
                    MOVLW   D'8'      ;SIND 125MSEC * 8 = 1SEC
                    MOVWF   ZAE1

TZ3                 CALL    I_ZS125MS
                    
TZ1                 BTFSC   PIR1, TMR1IF
                    GOTO    TZ2
                    BTFSS   PORTA, AUF_H
                    GOTO    ANF3
                    BTFSS   PORTA, AB_H
                    GOTO    ANF3
                    GOTO    TZ1

TZ2                 DECFSZ  ZAE1, F
                    GOTO    TZ3
                    BCF     T1CON, TMR1ON       ;STOP TIMER1
;----------------------------------------------
            BCF     NO_SENSOR, BIT0
            CALL    RESE
            BTFSC   NO_SENSOR, BIT0
            GOTO    MAIN

            MOVLW   0XCC                    ;ROM BRAUCHT JETZT NICHT GESENDET WERDEN
            CALL    TX
            MOVLW   0XBE                    ;AUFFORDERUNG ZUR TEMPERATUR AUSGABE
            CALL    TX                      ;NACH DIESEM BEFEHL MUESSEN ALSO DIE TEMPERATUR USW... SOFORT EMPFANGEN WERDEN

;TEMPERATUR AUSLESEN AUS SENSOR DS18S20
            CALL    RX                      ;EIN BYTE EMPFANGEN
            MOVWF   TEMP_L                  ;ABSPEICHERN DES ERGEBNISBYTES IN TEMP_L
            CALL    RX                      ;EIN BYTE EMPFANGEN
            MOVWF   TEMP_H                  ;ABSPEICHERN DES ERGEBNISBYTES IN TEMP_H

            
            
            BCF     STATUS, C               ;ALS DS18B20 KORRIGIEREN / UMCODIEREN
            RRF     TEMP_H, F
            RRF     TEMP_L, F

            BCF     STATUS, C
            RRF     TEMP_H, F
            RRF     TEMP_L, F

            BCF     STATUS, C
            RRF     TEMP_H, F
            RRF     TEMP_L, F            

            
            
        
;ANZEIGE DER TEMPERATUR AUF LCD-DOT-DISPLAY
            CALL    IS                      ;TEXT "IST C ,"
            BCF     IA, BIT0                ;IST-TEMP-ANZEIGE
            CALL    BCD_ANZEIGE             ;HEX ZU BCD UMRECHNEN UND ANZEIGE

;TEMPERATUR-RELAIS-SCHALTEN MIT HEIZEN ODER KHLEN
            BTFSS   MOD, BIT0
            GOTO    ZZZZ
            CALL    HEIZEN
            GOTO    ANF3

ZZZZ        CALL    KUEHLEN
            GOTO    ANF3
;----------

;*****************************************************************************
;*         UNTERPROGRAMM KUEHLEN                                             *
;*                                                                           *
;*****************************************************************************
KUEHLEN     BTFSC   TEMPH_H, BIT2           ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    KHEI3 

            BTFSC   TEMPN_H, BIT2           ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    KHEI2                   ;MINUS NIEDRIGE TEMP 

            BTFSC   TEMP_H, BIT2            ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    KHEI1                   ;MINUS IST-TEMP
    
;RELAIS WIRD BEI BESTIMMTEN TEMPERATUREN AUS ODER EINGESCHALTET
;ES SIND JETZT NUR POSITIVE TEMPERATUREN
            BTFSC   ZUSTAND, BIT7
            CALL    KREL_AUS

            BTFSS   ZUSTAND, BIT7
            CALL    KREL_EIN
            RETURN


;IST-TEMP IST NEGATIV / NIEDRIGE + HOHE TEMP POSITIV
KHEI1       BCF     ZUSTAND, BIT7               ;MERKER AUF AUS GESETZT
            CALL    AU                         
            CALL    AUS                         
            RETURN


;NIEDRIGE TEMP IST NEGATIV / HOHE TEMP IST POSITIV / IST-TEMP KANN NEGATIV + POSITIV SEIN
KHEI2       BTFSC   TEMP_H, BIT2                ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    KHEI2A

            BTFSS   ZUSTAND, BIT7               ;NACH DEM ES EINMAL EINGESCHALTET HAT WARTET ES BIS ES DIE HOHE TEMP BERSCHRITTEN HAT DANN KHLT ES
            CALL    KREL_EIN
            RETURN

;BEI MINUS IST-TEMP + BEI MINUS NIEDRIGE TEMP + BEI POS. HOHE TEMP 
KHEI2A      MOVF    TEMPN_L, W      ;TEMPN_L SICHERN IN TEMPN_MERK 
            MOVWF   TEMPN_MERK
            COMF    TEMPN_MERK, F
;---
            MOVF    TEMP_L, W       ;AUCH IST TEMP MIT 0,5C MERKEN
            COMF    TEMP_L, F
;---
            MOVF    TEMPN_MERK, W               
            SUBWF   TEMP_L, W                   ;MESSWERT(TEMP_L) - SCHALT-WERT-TEMPERATUR (TEMPN_MERK)
            BTFSS   STATUS, C                   ;BEI IST-MESSWERT GRER/GLEICH IST CARRY=HIGH, ES ERFOLGT EIN SPRUNG, ES GEHT AUF AUS / ES KHLT NICHT MEHR
            GOTO    KHEI2B ;RETURN
            CALL    AU                          ;TEXT 
            CALL    AUS                         ;RELAIS
            BCF     ZUSTAND, BIT7               ;MERKER
            BSF     ZUSTAND, BIT0
            RETURN

KHEI2B      BTFSC   ZUSTAND, BIT7
            RETURN
            BTFSC   ZUSTAND, BIT0               ;FR EINMAL NUR BEIM EINSCHALTEN BEI MINUS ABER HHER NIEDRIGE TEMP.
            RETURN
            CALL    AU
            CALL    AUS
            BCF     ZUSTAND, BIT7
            BSF     ZUSTAND, BIT0
            RETURN


;NIEDRIGE TEMP IST NEGATIV / HOHE TEMP IST NEGATIV / IST-TEMP KANN NEGATIV + POSITIV SEIN
KHEI3       BTFSC   TEMP_H, BIT2                ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    KHEI3A

            CALL    EI                          ;TEXT
            CALL    EIN                         ;RELAIS
            BSF     ZUSTAND, BIT7               ;MERKER
            RETURN


KHEI3A      MOVF    TEMPN_L, W      ;TEMPN_L SICHERN IN TEMPN_MERK 
            MOVWF   TEMPN_MERK
            COMF    TEMPN_MERK, F
;---
            MOVF    TEMPH_L, W      ;TEMPH_L SICHERN IN TEMPH_MERK 
            MOVWF   TEMPH_MERK
            COMF    TEMPH_MERK, F
;---
            MOVF    TEMP_L, W       ;AUCH IST TEMP MIT 0,5C MERKEN
            COMF    TEMP_L, F
;---
            BTFSS   ZUSTAND, BIT7               ;NEGATIVE IST-TEMP 
            CALL    KREL_EIN_M

            BTFSC   ZUSTAND, BIT7               ;NEGATIVE IST-TEMP 
            CALL    KREL_AUS_M
            RETURN



;*****************************************************************************
;*                        UNTERPROGRAMM FUER DAS RELAIS-SCHALTEN             *
;*                              02.04.11                                     *
;*****************************************************************************
KREL_EIN    MOVF    TEMPH_L, W
            SUBWF   TEMP_L, W                   ;MESSWERT(TEMP_L) - SCHALTTEMPERATUR (TEMPH_L)
            BTFSS   STATUS, C                   ;BEI MESSWERT GRER/GLEICH IST CARRY=HIGH, ES ERFOLGT EIN SPRUNG, ES GEHT AUF EIN
            GOTO    KA11
            CALL    EI                          ;TEXT FR "EIN"
            CALL    EIN                         ;RELAIS AUF EIN
            BSF     ZUSTAND, BIT7               ;MERKER AUF EIN GESETZT
            RETURN

KA11        CALL    AU                          ;TEXT FR "AUS"
            CALL    AUS                         ;RELAIS AUF AUS
            RETURN

;*****************************************************************************
;*                        UNTERPROGRAMM FUER DAS RELAIS-SCHALTEN             *
;*                              02.04.11                                     *
;*****************************************************************************
KREL_EIN_M  MOVF    TEMPH_MERK, W               
            SUBWF   TEMP_L, W                   ;MESSWERT(TEMP_L) - SCHALT-WERT-TEMPERATUR (TEMPH_MERK)
            BTFSC   STATUS, C                   ;BEI IST-MESSWERT KLEINER IST CARRY=LOW, ES ERFOLGT EIN SPRUNG, ES GEHT AUF EIN, ES KHLT
            GOTO    KA12
            CALL    EI                          ;TEXT
            CALL    EIN                         ;RELAIS
            BSF     ZUSTAND, BIT7               ;MERKER
            RETURN

KA12        CALL    AU                          ;TEXT
            CALL    AUS                         ;RELAIS 
            ;BCF     ZUSTAND, BIT7               ;MERKER 
            RETURN

;*****************************************************************************
;*                        UNTERPROGRAMM FUER DAS RELAIS-SCHALTEN             *
;*                              02.04.11                                     *
;*****************************************************************************
KREL_AUS    MOVF    TEMPN_L, W
            SUBWF   TEMP_L, W                   ;MESSWERT(TEMP_L) - SCHALTTEMPERATUR (TEMPN_L)
            BTFSC   STATUS, C                   ;BEI IST-MESSWERT KLEINER IST CARRY=HIGH, ES ERFOLGT EIN SPRUNG, ES GEHT AUF AUS
            GOTO    KA10
            CALL    AU                          ;TEXT FR "AUS"
            CALL    AUS                         ;RELAIS AUF AUS
            BCF     ZUSTAND, BIT7               ;MERKER AUF AUS GESETZT
            RETURN

KA10        CALL    EI                          ;TEXT FR "EIN"
            CALL    EIN                         ;RELAIS AUF EIN
            RETURN


;*****************************************************************************
;*                        UNTERPROGRAMM FUER DAS RELAIS-SCHALTEN             *
;*                              02.04.11                                     *
;*****************************************************************************
KREL_AUS_M  MOVF    TEMPN_MERK, W               
            SUBWF   TEMP_L, W                   ;MESSWERT(TEMP_L) - SCHALT-WERT-TEMPERATUR (TEMPN_MERK)
            BTFSS   STATUS, C                   ;BEI IST-MESSWERT GRER/GLEICH IST CARRY=HIGH, ES ERFOLGT EIN SPRUNG, ES GEHT AUF AUS / ES KHLT NICHT MEHR
            GOTO    KA13
            CALL    AU                          ;TEXT 
            CALL    AUS                         ;RELAIS
            BCF     ZUSTAND, BIT7               ;MERKER
            RETURN

KA13        CALL    EI                          ;TEXT
            CALL    EIN                         ;RELAIS
            ;BSF     ZUSTAND, BIT7               ;MERKER 
            RETURN

;*****************************************************************************
;*         UNTERPROGRAMM HEIZEN                                              *
;*                                                                           *
;*****************************************************************************
HEIZEN      BTFSC   TEMPH_H, BIT2           ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    HEI3 

            BTFSC   TEMPN_H, BIT2           ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    HEI2                    ;MINUS NIEDRIGE TEMP 

            BTFSC   TEMP_H, BIT2            ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    HEI1                    ;MINUS IST-TEMP
    
;RELAIS WIRD BEI BESTIMMTEN TEMPERATUREN AUS ODER EINGESCHALTET
;ES SIND JETZT NUR POSITIVE TEMPERATUREN
            BTFSC   ZUSTAND, BIT7
            CALL    REL_AUS

            BTFSS   ZUSTAND, BIT7
            CALL    REL_EIN
            RETURN

;BEI MINUS IST-TEMP + POS.EINSTELL-TEMP ALLE /ALSO POS. NIEDRIGE UND HOHE TEMP.
HEI1        CALL    EI                          ;TEXT FR "EIN"
            CALL    EIN                         ;RELAIS AUF EIN
            BSF     ZUSTAND, BIT7               ;MERKER AUF EIN GESETZT
            RETURN

;BEI MINUS NIEDRIGE TEMP + BEI POS. HOHE TEMP + IST TEMP POSITIV + NEGATIV
HEI2        BTFSC   TEMP_H, BIT2                ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    HEI2A

            BTFSS   ZUSTAND, BIT7               ;NACH DEM ES EINMAL EINGESCHALTET HAT WARTET ES BIS ES DIE HOHE TEMP BERSCHRITTEN HAT
            GOTO    HEI2B
            MOVF    TEMPH_L, W
            SUBWF   TEMP_L, W                   ;MESSWERT(TEMP_L) - SCHALTTEMPERATUR (TEMPH_L)
            BTFSS   STATUS, C                   ;BEI MESSWERT GRSSER/GLEICH IST CARRY=HIGH, ES ERFOLGT EIN SPRUNG, ES GEHT AUF AUS
            RETURN
            CALL    AU                          ;TEXT FR "AUS"
            CALL    AUS                         ;RELAIS AUF AUS
            BCF     ZUSTAND, BIT7               ;MERKER AUF AUS GESETZT
            RETURN

HEI2B       CALL    AU                          ;TEXT FR "AUS"
            CALL    AUS                         ;RELAIS AUF AUS
            BCF     ZUSTAND, BIT7               ;MERKER ????
            RETURN

;BEI MINUS IST-TEMP + BEI MINUS NIEDRIGE TEMP + BEI POS. HOHE TEMP 
HEI2A       MOVF    TEMPN_L, W      ;TEMPN_L SICHERN IN TEMPN_MERK 
            MOVWF   TEMPN_MERK
            COMF    TEMPN_MERK, F
;---
            MOVF    TEMP_L, W       ;AUCH IST TEMP MIT 0,5C MERKEN
            COMF    TEMP_L, F
;---
            BTFSS   ZUSTAND, BIT7               ;NEGATIVE IST-TEMP 
            CALL    REL_EIN_M
            RETURN

;ALLES EINSTELLTEMP. NEGATIV / MESSWERT KANN POS + NEGTIV SEIN
HEI3        BTFSC   TEMP_H, BIT2                ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    HEI3A

            CALL    AU                          ;TEXT FR "AUS"
            CALL    AUS                         ;RELAIS AUF AUS
            BCF     ZUSTAND, BIT7               ;MERKER ????
            RETURN

HEI3A       MOVF    TEMPN_L, W      ;TEMPN_L SICHERN IN TEMPN_MERK 
            MOVWF   TEMPN_MERK
            COMF    TEMPN_MERK, F
;---
            MOVF    TEMPH_L, W      ;TEMPH_L SICHERN IN TEMPH_MERK 
            MOVWF   TEMPH_MERK
            COMF    TEMPH_MERK, F
;---
            MOVF    TEMP_L, W       ;AUCH IST TEMP MIT 0,5C MERKEN
            COMF    TEMP_L, F
;---
            BTFSC   ZUSTAND, BIT7               ;NEGATIVE IST-TEMP 
            CALL    REL_AUS_M

            BTFSS   ZUSTAND, BIT7               ;NEGATIVE IST-TEMP 
            CALL    REL_EIN_M
            RETURN


;*****************************************************************************
;*                        UNTERPROGRAMM FUER DAS RELAIS-SCHALTEN             *
;*                              02.04.11                                     *
;*****************************************************************************
REL_AUS     MOVF    TEMPH_L, W
            SUBWF   TEMP_L, W                   ;MESSWERT(TEMP_L) - SCHALTTEMPERATUR (TEMPH_L)
            BTFSS   STATUS, C                   ;BEI MESSWERT GRSSER/GLEICH IST CARRY=HIGH, ES ERFOLGT EIN SPRUNG, ES GEHT AUF AUS
            GOTO    A10
            CALL    AU                          ;TEXT FR "AUS"
            CALL    AUS                         ;RELAIS AUF AUS
            BCF     ZUSTAND, BIT7               ;MERKER AUF AUS GESETZT
            RETURN

A10         CALL    EI                          ;TEXT FR "EIN"
            CALL    EIN                         ;RELAIS AUF EIN
            RETURN

;*****************************************************************************
;*                        UNTERPROGRAMM FUER DAS RELAIS-SCHALTEN             *
;*                              02.04.11                                     *
;*****************************************************************************
REL_AUS_M   MOVF    TEMP_L, W                   ;Z.B.: IST-TEMP -5C + HOHE-TEMP -10C
            SUBWF   TEMPH_MERK, W               ;SCHALT-WERT-TEMPERATUR (TEMPH_MERK) - MESSWERT(TEMP_L)
            BTFSS   STATUS, C                   ;BEI SCHALTWERT ALS ZAHL OHNE - / GRER/GLEICH IST CARRY=HIGH, ES ERFOLGT EIN SPRUNG, ES GEHT AUF AUS / ES HEIZT NICHT MEHR
            GOTO    A13
            CALL    AU                          ;TEXT 
            CALL    AUS                         ;RELAIS
            BCF     ZUSTAND, BIT7               ;MERKER
            RETURN

A13         CALL    EI                          ;TEXT
            CALL    EIN                         ;RELAIS
            BSF     ZUSTAND, BIT7               ;MERKER ????
            RETURN
;*****************************************************************************
;*                        UNTERPROGRAMM FUER DAS RELAIS-SCHALTEN             *
;*                              02.04.11                                     *
;*****************************************************************************
REL_EIN     MOVF    TEMPN_L, W
            SUBWF   TEMP_L, W                   ;MESSWERT(TEMP_L) - SCHALTTEMPERATUR (TEMPN_L)
            BTFSC   STATUS, C                   ;BEI MESSWERT KLEINER IST CARRY=LOW, ES ERFOLGT EIN SPRUNG, ES GEHT AUF EIN
            GOTO    A11
            CALL    EI                          ;TEXT FR "EIN"
            CALL    EIN                         ;RELAIS AUF EIN
            BSF     ZUSTAND, BIT7               ;MERKER AUF EIN GESETZT
            RETURN

A11         CALL    AU                          ;TEXT FR "AUS"
            CALL    AUS                         ;RELAIS AUF AUS
            RETURN

;*****************************************************************************
;*                        UNTERPROGRAMM FUER DAS RELAIS-SCHALTEN             *
;*                              02.04.11                                     *
;*****************************************************************************
REL_EIN_M   MOVF    TEMPN_MERK, W               ;Z.B.: IST-TEMP -10C + NIEDRIGE-TEMP -5C
            SUBWF   TEMP_L, W                   ;MESSWERT(TEMP_L) - SCHALT-WERT-TEMPERATUR (TEMPN_MERK)
            BTFSS   STATUS, C                   ;BEI MESSWERT GRER/GLEICH IST CARRY=HIGH, ES ERFOLGT EIN SPRUNG, ES GEHT AUF EIN, ES HEIZT
            GOTO    A12
            CALL    EI                          ;TEXT FR "EIN"
            CALL    EIN                         ;RELAIS AUF EIN
            BSF     ZUSTAND, BIT7               ;MERKER AUF EIN GESETZT
            RETURN

A12         CALL    AU                          ;TEXT FR "AUS"
            CALL    AUS                         ;RELAIS AUF AUS
            BCF     ZUSTAND, BIT7               ;MERKER ????
            RETURN

;*****************************************************************************
;*         UNTERPROGRAMM AUF+AB STELLEN                                      *
;*                                                                           *
;*****************************************************************************
AUFAB               ;CALL    AUS         ;HEIZEN ODER KHLEN AUSSCHALTEN BEIM EINSTELLEN

                    MOVLW   D'50'      
                    MOVWF   ZAE2

                    MOVLW   D'80'      ;SIND 125MSEC * 80 = 10SEC
                    MOVWF   ZAE1

;ZEITSCHLEIFE VON 10SEC REIN, WENN KEIN TASTER GEDRCKT WURDE AUFHREN

TM3                 CALL    I_ZS125MS
                    
TM1                 BTFSC   PIR1, TMR1IF
                    GOTO    TM2
                    BTFSS   PORTA, AUF_H
                    GOTO    EITA
                    BTFSS   PORTA, AB_H
                    GOTO    EITC
                    BTFSS   PORTB, AUF_L
                    GOTO    EITE
                    BTFSS   PORTB, AB_L
                    GOTO    EITF
                    GOTO    TM1

TM2                 DECFSZ  ZAE1, F
                    GOTO    TM3
                    BCF     T1CON, TMR1ON       ;STOP TIMER1

                    CALL    SPEI            ;ZWISCHENSPEICHERN DER EINSTELLUNGEN
                    CALL    LE              ;ANZEIGE ST (STELLEN) WEG MIT "  "
                    CALL    IS              ;TEXT "IST"...
                    RETURN

;---------------------------------------------------------------------------------------
;GEDRCKT AB-TASTER NIEDRIGE TEMP.
EITF                BCF     T1CON, TMR1ON       ;STOP TIMER1
                    MOVLW   D'40'           ;ENTPRELLUNG 40MSEC, 
                    MOVWF   HELP2
FEITD               BTFSC   PORTB, AB_L
                    GOTO    AUFAB
                    MOVLW   D'1'
                    CALL    ZS1MS          ;1MSEC
                    DECFSZ  HELP2, F
                    GOTO    FEITD

;REPEAT
FRPAB               MOVF    ZAE2, W          ;ENTPRELLUNG 150MSEC, 
                    MOVWF   HELP2
FTBW                BTFSC   PORTB, AB_L
                    GOTO    FEITCC
                    MOVLW   D'3'
                    CALL    ZS1MS          ;10MSEC
                    DECFSZ  HELP2, F
                    GOTO    FTBW

                    DECF    ZAE2, F
                    MOVLW   H'03'                ;NICHT NIEDRIGER ZHLEN
                    SUBWF   ZAE2, W
                    BTFSC   STATUS, Z
                    INCF    ZAE2, F

                    BSF     MERK1, BIT0     ;REPEAT MERKER
                    GOTO    FWW2

;LOSLASSEN AB-TASTER
FEITCC              MOVLW   D'40'           ;ENTPRELLUNG 40MSEC, 
                    MOVWF   HELP2
FEITDD              BTFSS   PORTB, AB_L
                    GOTO    FEITCC
                    MOVLW   D'1'
                    CALL    ZS1MS          ;1MSEC
                    DECFSZ  HELP2, F
                    GOTO    FEITDD

                    BTFSS   MERK1, BIT0     ;REPEAT MERKER
                    GOTO    FWW2
                    CLRF    MERK1
                    GOTO    AUFAB

;--------------------
FWW2                BTFSC   TEMPN_H, BIT2            ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR

                    ;MOVLW   H'00'       ;BEI POSITVEN TEMPERATUREN
                    ;SUBWF   TEMPN_H, W
                    ;BTFSS   STATUS, Z
                    GOTO    FWZ1         ;BEI NEGATIVEN TEMP.

                        MOVLW   H'00'                ;BEI 0C TEMPERATUR ZU 0XFF 0XFF MACHEN -0,5C
                        SUBWF   TEMPN_L, W
                        BTFSC   STATUS, Z
                        GOTO    FWZ2

                    DECF    TEMPN_L, F

FEZT0               MOVF    TEMPN_L, W
                    MOVWF   TEMP_L
                    MOVF    TEMPN_H, W
                    MOVWF   TEMP_H

                    BSF     IA, BIT0                ;AN WELCHE STELLE ANGEZEIGT WIRD EINSTELLEN
                    BCF     IA, BIT1
                    CALL    BCD_ANZEIGE

                    BTFSC   MERK1, BIT0
                    GOTO    FRPAB
                    GOTO    AUFAB

;NEGATIVE TEMP
FWZ1                ;MOVLW   B'10110000'                ;BEI MIN. TEMPERATUR -40C NICHT UNTERSCHREITEN
                    MOVLW   B'10011000'                ;BEI MIN. TEMPERATUR -52C NICHT UNTERSCHREITEN
                    SUBWF   TEMPN_L, W
                    BTFSC   STATUS, Z
                    GOTO    FEZT0

FWZ0                DECF    TEMPN_L, F
                    GOTO    FEZT0

;0C ZU -0,5C STELLEN
FWZ2                MOVLW   0XFF
                    MOVWF   TEMPN_L
                    MOVLW   0XFF
                    MOVWF   TEMPN_H
                    GOTO    FEZT0

;-------------------------------------------------------------------
;GEDRCKT AUF-TASTER NIEDRIGE TEMP.
EITE                BCF     T1CON, TMR1ON       ;STOP TIMER1
                    MOVLW   D'40'          ;ENTPRELLUNG 40MSEC, 
                    MOVWF   HELP2
EEITB               BTFSC   PORTB, AUF_L
                    GOTO    AUFAB
                    MOVLW   D'1'
                    CALL    ZS1MS          ;1MSEC
                    DECFSZ  HELP2, F
                    GOTO    EEITB

;REPEAT
ERPAUF              MOVF    ZAE2, W         ;ENTPRELLUNG 150MSEC, 
                    MOVWF   HELP2
ETB                 BTFSC   PORTB, AUF_L
                    GOTO    EEITAA
                    MOVLW   D'3'
                    CALL    ZS1MS          ;3MSEC
                    DECFSZ  HELP2, F
                    GOTO    ETB

                    DECF    ZAE2, F
                    MOVLW   H'03'                ;NICHT NIEDRIGER ZHLEN
                    SUBWF   ZAE2, W
                    BTFSC   STATUS, Z
                    INCF    ZAE2, F

                    BSF     MERK1, BIT0     ;REPEAT MERKER
                    GOTO    EWW1

;LOSLASSEN AUF-TASTER
EEITAA              MOVLW   D'40'           ;ENTPRELLUNG 40MSEC, 
                    MOVWF   HELP2
EEITBB              BTFSS   PORTB, AUF_L
                    GOTO    EEITAA
                    MOVLW   D'1'
                    CALL    ZS1MS          ;1MSEC
                    DECFSZ  HELP2, F
                    GOTO    EEITBB

                    BTFSS   MERK1, BIT0     ;REPEAT MERKER
                    GOTO    EWW1
                    CLRF    MERK1
                    GOTO    AUFAB

EWW1                BTFSC   TEMPN_H, BIT2            ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR

                        ;MOVLW   H'00'       ;BEI POSITVEN TEMPERATUREN
                        ;SUBWF   TEMPN_H, W
                        ;BTFSS   STATUS, Z
                    GOTO    EWE1        ;BEI NEGATIVEN TEMP.
    
                        ;MOVLW   B'11011100'         ;BEI MAX. TEMPERATUR +110C NICHT BERSCHREITEN
                        MOVLW   B'11110100'         ;BEI MAX. TEMPERATUR +122C NICHT BERSCHREITEN
                        SUBWF   TEMPN_L, W
                        BTFSC   STATUS, Z
                        GOTO    EEIT0

EEITT                   MOVF    TEMPH_L, W          ;DARF DIE HOHE TEMP NICHT BERSCHREITEN / NICHT EINSTELLBAR
                        SUBWF   TEMPN_L, W
                        BTFSC   STATUS, Z
                        GOTO    EEIT0

                    INCF    TEMPN_L, F

EEIT0               MOVF    TEMPN_L, W
                    MOVWF   TEMP_L
                    MOVF    TEMPN_H, W
                    MOVWF   TEMP_H

                    BSF     IA, BIT0                ;AN WELCHE STELLE ANGEZEIGT WIRD EINSTELLEN
                    BCF     IA, BIT1
                    CALL    BCD_ANZEIGE

                    BTFSC   MERK1, BIT0
                    GOTO    ERPAUF
                    GOTO    AUFAB

;NEGATIVE TEMP
EWE1                MOVLW   H'FF'           ;TESTEN OB ES -0,5C SIND DANN 0X00 UND 0X00 MACHEN 0,0C
                    SUBWF   TEMPN_L, W
                    BTFSC   STATUS, Z
                    GOTO    EWE2
      
                    MOVF    TEMPN_L, W      ;DARF DIE HOHE TEMP NICHT BERSCHREITEN / NICHT EINSTELLBAR
                    SUBWF   TEMPH_L, W
                    BTFSS   STATUS, Z
                    GOTO    EEIT2

                        BTFSC   TEMPH_H, BIT2            ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR

                        ;MOVLW   H'00'               ;DARF DIE HOHE TEMP NICHT BERSCHREITEN / NICHT EINSTELLBAR
                        ;SUBWF   TEMPH_H, W          ;TESTEN OB HOHE TEMPERATUR AUCH POSTIV IST
                        ;BTFSS   STATUS, Z
                        GOTO    EEIT0

EEIT2               INCF    TEMPN_L, F
                    GOTO    EEIT0

;0C STELLEN
EWE2                MOVLW   H'FF'           ;TESTEN OB ES AUCH -0,5C HOHE TEMP NICHT BERSCHREITEN
                    SUBWF   TEMPH_L, W
                    BTFSC   STATUS, Z
                    GOTO    EEIT0

                    CLRF    TEMPN_L
                    CLRF    TEMPN_H
                    GOTO    EEIT0

;-------------------------------------------------------------------
;GEDRCKT AUF-TASTER HOHE TEMP.
EITA                BCF     T1CON, TMR1ON       ;STOP TIMER1
                    MOVLW   D'40'          ;ENTPRELLUNG 40MSEC, 
                    MOVWF   HELP2
EITB                BTFSC   PORTA, AUF_H
                    GOTO    AUFAB
                    MOVLW   D'1'
                    CALL    ZS1MS          ;1MSEC
                    DECFSZ  HELP2, F
                    GOTO    EITB

;REPEAT
RPAUF               MOVF    ZAE2, W         ;ENTPRELLUNG 150MSEC, 
                    MOVWF   HELP2
TB                  BTFSC   PORTA, AUF_H
                    GOTO    EITAA
                    MOVLW   D'3'
                    CALL    ZS1MS          ;3MSEC
                    DECFSZ  HELP2, F
                    GOTO    TB

                    DECF    ZAE2, F
                        MOVLW   H'03'                ;NICHT NIEDRIGER ZHLEN
                        SUBWF   ZAE2, W
                        BTFSC   STATUS, Z
                        INCF    ZAE2, F

                    BSF     MERK1, BIT0     ;REPEAT MERKER
                    GOTO    WW1

;LOSLASSEN AUF-TASTER
EITAA               MOVLW   D'40'           ;ENTPRELLUNG 40MSEC, 
                    MOVWF   HELP2
EITBB               BTFSS   PORTA, AUF_H
                    GOTO    EITAA
                    MOVLW   D'1'
                    CALL    ZS1MS          ;1MSEC
                    DECFSZ  HELP2, F
                    GOTO    EITBB

                    BTFSS   MERK1, BIT0     ;REPEAT MERKER
                    GOTO    WW1
                    CLRF    MERK1
                    GOTO    AUFAB

WW1                BTFSC   TEMPH_H, BIT2            ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR

                        ;MOVLW   H'00'       ;BEI POSITVEN TEMPERATUREN
                        ;SUBWF   TEMPH_H, W
                        ;BTFSS   STATUS, Z
                   GOTO    WE1         ;BEI NEGATIVEN TEMP.
    
                        ;MOVLW   B'11011100'                ;BEI MAX. TEMPERATUR 110C NICHT BERSCHREITEN
                        MOVLW   B'11110100'         ;BEI MAX. TEMPERATUR +122C NICHT BERSCHREITEN
                        SUBWF   TEMPH_L, W
                        BTFSC   STATUS, Z
                        GOTO    EIT0

                    INCF    TEMPH_L, F

EIT0                MOVF    TEMPH_L, W
                    MOVWF   TEMP_L
                    MOVF    TEMPH_H, W
                    MOVWF   TEMP_H

                    BSF     IA, BIT0                ;AN WELCHE STELLE ANGEZEIGT WIRD EINSTELLEN
                    BSF     IA, BIT1
                    CALL    BCD_ANZEIGE

                    BTFSC   MERK1, BIT0
                    GOTO    RPAUF
                    GOTO    AUFAB

;NEGATIVE TEMP
WE1                 MOVLW   H'FF'           ;TESTEN OB ES -0,5C SIND DANN 0X00 UND 0X00 MACHEN
                    SUBWF   TEMPH_L, W
                    BTFSC   STATUS, Z
                    GOTO    WE2

                    INCF    TEMPH_L, F
                    GOTO    EIT0

;0C STELLEN
WE2                 CLRF    TEMPH_L
                    CLRF    TEMPH_H
                    GOTO    EIT0

;---------------------------------------------------------------------------------------
;GEDRCKT AB-TASTER HOHE TEMP.
EITC                BCF     T1CON, TMR1ON       ;STOP TIMER1
                    MOVLW   D'40'           ;ENTPRELLUNG 40MSEC, 
                    MOVWF   HELP2
EITD                BTFSC   PORTA, AB_H
                    GOTO    AUFAB
                    MOVLW   D'1'
                    CALL    ZS1MS          ;1MSEC
                    DECFSZ  HELP2, F
                    GOTO    EITD

;REPEAT
RPAB                MOVF    ZAE2, W          ;ENTPRELLUNG 150MSEC, 
                    MOVWF   HELP2
TBW                 BTFSC   PORTA, AB_H
                    GOTO    EITCC
                    MOVLW   D'3'
                    CALL    ZS1MS          ;10MSEC
                    DECFSZ  HELP2, F
                    GOTO    TBW

                    DECF    ZAE2, F
                    MOVLW   H'03'                ;NICHT NIEDRIGER ZHLEN
                    SUBWF   ZAE2, W
                    BTFSC   STATUS, Z
                    INCF    ZAE2, F

                    BSF     MERK1, BIT0     ;REPEAT MERKER
                    GOTO    WW2

;LOSLASSEN AB-TASTER
EITCC               MOVLW   D'40'           ;ENTPRELLUNG 40MSEC, 
                    MOVWF   HELP2
EITDD               BTFSS   PORTA, AB_H
                    GOTO    EITCC
                    MOVLW   D'1'
                    CALL    ZS1MS          ;1MSEC
                    DECFSZ  HELP2, F
                    GOTO    EITDD

                    BTFSS   MERK1, BIT0     ;REPEAT MERKER
                    GOTO    WW2
                    CLRF    MERK1
                    GOTO    AUFAB

;--------------------
WW2                BTFSC   TEMPH_H, BIT2            ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR

                        ;MOVLW   H'00'       ;BEI POSITVEN TEMPERATUREN
                        ;SUBWF   TEMPH_H, W
                        ;BTFSS   STATUS, Z
                   GOTO    WZ1         ;BEI NEGATIVEN TEMP.

                        MOVLW   H'00'                ;BEI 0C TEMPERATUR ZU 0XFF 0XFF MACHEN -0,5C
                        SUBWF   TEMPH_L, W
                        BTFSC   STATUS, Z
                        GOTO    WZ2
    
                        MOVF    TEMPH_L, W          ;DARF DIE HOHE TEMP NICHT UNTERSCHREITEN / NICHT EINSTELLBAR
                        SUBWF   TEMPN_L, W
                        BTFSS   STATUS, Z
                        GOTO    ETZ

                        MOVLW   H'FF'               ;DARF DIE HOHE TEMP NICHT BERSCHREITEN / NICHT EINSTELLBAR
                        SUBWF   TEMPN_H, W          ;TESTEN OB NIEDRIGE TEMPERATUR NEGATIV IST
                        BTFSS   STATUS, Z
                        GOTO    EZT0               

ETZ                 DECF    TEMPH_L, F

EZT0                MOVF    TEMPH_L, W
                    MOVWF   TEMP_L
                    MOVF    TEMPH_H, W
                    MOVWF   TEMP_H

                    BSF     IA, BIT0                ;AN WELCHE STELLE ANGEZEIGT WIRD EINSTELLEN
                    BSF     IA, BIT1
                    CALL    BCD_ANZEIGE

                    BTFSC   MERK1, BIT0
                    GOTO    RPAB
                    GOTO    AUFAB

;NEGATIVE TEMP
WZ1                 ;MOVLW   B'10110000'                ;BEI MIN. TEMPERATUR -40C NICHT UNTERSCHREITEN
                    MOVLW   B'10011000'                ;BEI MIN. TEMPERATUR -52C NICHT UNTERSCHREITEN
                    SUBWF   TEMPH_L, W
                    BTFSC   STATUS, Z
                    GOTO    EZT0

                    MOVF    TEMPH_L, W          ;DARF DIE TEMP NICHT UNTERSCHREITEN / NICHT EINSTELLBAR
                    SUBWF   TEMPN_L, W
                    BTFSC   STATUS, Z
                    GOTO    EZT0

                    DECF    TEMPH_L, F
                    GOTO    EZT0

;0C ZU -0,5C STELLEN
WZ2                 MOVF    TEMPH_L, W          ;DARF DIE TEMP NICHT UNTERSCHREITEN / NICHT EINSTELLBAR
                    SUBWF   TEMPN_L, W
                    BTFSC   STATUS, Z
                    GOTO    EZT0

                    MOVLW   0XFF
                    MOVWF   TEMPH_L
                    MOVLW   0XFF
                    MOVWF   TEMPH_H
                    GOTO    EZT0

;*****************************************************************************
;*                              TEMPERATUREINSTELLUNG SPEICHERN              *
;*                              13.03.15                                     *
;*****************************************************************************
SPEI        MOVLW   H'00'
            MOVWF   ADR
            MOVF    TEMPH_H, W
            CALL    E_WRITE

            INCF    ADR, F
            MOVF    TEMPH_L, W
            CALL    E_WRITE

            INCF    ADR, F
            MOVF    TEMPN_H, W
            CALL    E_WRITE

            INCF    ADR, F
            MOVF    TEMPN_L, W
            CALL    E_WRITE

            RETURN

;*****************************************************************************
;*                              TEMPERATUREINSTELLUNG SPEICHERN              *
;*                              13.03.15                                     *
;*****************************************************************************
SPEI_NEU    MOVLW   H'00'
            MOVWF   ADR
            MOVLW   H'00'       ;TEMPH_H
            MOVWF   TEMPH_H
            MOVWF   TEMP_H
            CALL    E_WRITE

            MOVLW   H'01'
            MOVWF   ADR
            MOVLW   H'32'       ;TEMPH_L
            MOVWF   TEMPH_L
            CALL    E_WRITE
            MOVF    TEMPH_L, W
            MOVWF   TEMP_L
            BSF     IA, BIT0                ;AN WELCHE STELLE ANGEZEIGT WIRD EINSTELLEN
            BSF     IA, BIT1
            CALL    BCD_ANZEIGE             ;HEX ZU BCD UMRECHNEN UND ANZEIGE


            INCF    ADR, F
            MOVLW   H'00'       ;TEMPN_H
            MOVWF   TEMPN_H
            MOVWF   TEMP_H
            CALL    E_WRITE

            INCF    ADR, F
            MOVLW   H'0F'       ;TEMPN_L
            MOVWF   TEMPN_L
            CALL    E_WRITE
            MOVF    TEMPN_L, W
            MOVWF   TEMP_L
            BSF     IA, BIT0                ;AN WELCHE STELLE ANGEZEIGT WIRD EINSTELLEN
            BCF     IA, BIT1
            CALL    BCD_ANZEIGE             ;HEX ZU BCD UMRECHNEN UND ANZEIGE


            INCF    ADR, F
            MOVLW   H'00'       ;NACH 1-TEM START
            CALL    E_WRITE

            RETURN

;*****************************************************************************
;*                              EEPROM READ                                  *
;*                              16.12.08                                     *
;*****************************************************************************
E_READ          BANK1
                MOVWF   EEADR
                BSF     EECON1, RD
EE1             BTFSC   EECON1, RD
                GOTO    EE1
                MOVF    EEDATA, W
                BANK0
                RETURN
;AM ANFANG MUSS W MIT DER EEPROM-ADRESSE GELADEN SEIN
;DAS ERGEBNIS DES WERTES VOM EEPROM-INHALT STEHT AM ENDE IN W

;*****************************************************************************
;*                              EEPROM WRITE                                 *
;*                              17.12.08                                     *
;*****************************************************************************
E_WRITE         BCF     PIR1, EEIF
                BANK1
                MOVWF   EEDATA
                BANK0
                MOVF    ADR, W                    ;EEPROM-ADRESSE
                BANK1
                MOVWF   EEADR

                BSF     EECON1, WREN
                MOVLW   0X55
                MOVWF   EECON2
                MOVLW   0XAA
                MOVWF   EECON2
                BSF     EECON1, WR
W_1             BTFSC   EECON1, WR
                GOTO    W_1
                BSF     EECON1, WREN
                BANK0
                RETURN
;DIE EEPROMADRESSE MUSS IN ADR STEHEN
;DAS ZU SPEICHERNDE BYTE IN W


;*****************************************************************************
;*                        UNTERPROGRAMM BCD-UMRECHNUNG UND ANZEIGE           *
;*                        DIES IST NUR MAL GANZ SCHNELL ZUSAMMEN GEPFUSCHT   *
;*                        DESHALB STEHEN NUR GANZ WENIGE KOMMENTARE DRIN     *
;*                              31.03.11                                     *
;*****************************************************************************
BCD_ANZEIGE CLRF    MERKE

            MOVF    TEMP_L, W
            MOVWF   TEM

            BCF     STATUS, C
            RRF     TEM, F

W11W        BTFSS   STATUS, C
            GOTO    W5

            BTFSS   IA, BIT0
            GOTO    WA0

            BTFSS   IA, BIT1
            GOTO    WB0

            MOVLW   H'CC'                   ;ADRESSE 5 HOHE
            CALL    BEFEHL
            MOVLW   H'35'                   ;0.5C DIE 5
            CALL    DATEN
            GOTO    W00W

WB0         MOVLW   H'C4'                   ;ADRESSE 5 NIEDRIGE
            CALL    BEFEHL
            MOVLW   H'35'                   ;0.5C DIE 5
            CALL    DATEN
            GOTO    W00W
             
WA0         MOVLW   H'88'                   ;ADRESSE 5
            CALL    BEFEHL
            MOVLW   H'35'                   ;0.5C DIE 5
            CALL    DATEN
            GOTO    W00W
            
W5          BTFSS   IA, BIT0
            GOTO    WA1

            BTFSS   IA, BIT1
            GOTO    WB1

            MOVLW   H'CC'                   ;ADRESSE 5 HOHE
            CALL    BEFEHL
            MOVLW   H'30'                   ;0.0C DIE 0
            CALL    DATEN
            BSF     MERKE, BIT0
            GOTO    W00W

WB1         MOVLW   H'C4'                   ;ADRESSE 5 NIEDRIGE
            CALL    BEFEHL
            MOVLW   H'30'                   ;0.0C DIE 0
            CALL    DATEN
            BSF     MERKE, BIT0
            GOTO    W00W

WA1         MOVLW   H'88'                   ;ADRESSE 5
            CALL    BEFEHL
            MOVLW   H'30'                   ;0.0C DIE 0
            CALL    DATEN
            BSF     MERKE, BIT0

;-------
W00W        BTFSS   TEMP_H, BIT2            ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    WMW                    
            ;MOVF    TEMP_L, W
            ;MOVWF   TEM
            ;BSF     STATUS, C
            ;RRF     TEM, F

            COMF    TEM, F
            BCF     TEM, BIT7

            BTFSS   MERKE, BIT0
            GOTO    WMW
            INCF    TEM, F

WMW         CLRF    ANZ_L
            CLRF    ANZ_H

            BTFSS   TEM, BIT0
            GOTO    W001
            MOVLW   0X01
            MOVWF   ANZ_L

W001        BTFSS   TEM, BIT1
            GOTO    W002
            MOVF    ANZ_L, W
            ADDLW   0X02
            MOVWF   ANZ_L

W002        BTFSS   TEM, BIT2
            GOTO    W003
            MOVF    ANZ_L, W
            ADDLW   0X04
            MOVWF   ANZ_L

;-------

W003        BTFSS   TEM, BIT3
            GOTO    W004
            MOVLW   D'8'
            MOVWF   ZAE

W003B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W003A
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L

W003A       DECFSZ  ZAE, F
            GOTO    W003B

;--------

W004        BTFSS   TEM, BIT4
            GOTO    W005
            MOVLW   D'16'
            MOVWF   ZAE

W004B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W004A
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L

W004A       DECFSZ  ZAE, F
            GOTO    W004B

;--------

W005        BTFSS   TEM, BIT5
            GOTO    W006
            MOVLW   D'32'
            MOVWF   ZAE

W005B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W005A
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L 

W005A       DECFSZ  ZAE, F
            GOTO    W005B

;--------

W006        BTFSS   TEM, BIT6
            GOTO    W007
            MOVLW   D'64'
            MOVWF   ZAE

W006B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W006A
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L

            MOVF    ANZ_L, W
            ANDLW   0XFF
            MOVWF   VER 
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W006A
            CLRF    ANZ_L
            MOVF    ANZ_H, W
            ANDLW   0X0F
            ADDLW   0X01
            MOVWF   ANZ_H

W006A       DECFSZ  ZAE, F
            GOTO    W006B

;--------

W007        BTFSS   TEM, BIT7
            GOTO    W008
            MOVLW   D'128'
            MOVWF   ZAE

W007B       INCF    ANZ_L, F
            MOVF    ANZ_L, W
            ANDLW   0X0F
            MOVWF   VER
            MOVLW   0X0A
            SUBWF   VER, W
            BTFSS   STATUS, Z
            MOVF    ANZ_L, W
            ANDLW   0XF0
            ADDLW   0X10
            MOVWF   ANZ_L

            MOVF    ANZ_L, W
            ANDLW   0XFF
            MOVWF   VER
            MOVLW   0XA0
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W007A
            CLRF    ANZ_L
            MOVF    ANZ_H, W
            ANDLW   0X0F
            ADDLW   0X01
            MOVWF   ANZ_H

W007A       DECFSZ  ZAE, F
            GOTO    W007B


;------------
;BCD-ANZEIGE

W008        CLRF    MERKE                    ;
            CLRF    MINUS        
            BTFSS   TEMP_H, BIT2            ;BIT2 WAHLLOS GEWHLT, ES MUSS 00HEX SEIN BEI POSITIVER TEMPERATUR
            GOTO    W111        
            BSF     MINUS, BIT0     

W111        BTFSS   IA, BIT0
            GOTO    WA2

            BTFSS   IA, BIT1
            GOTO    WB2

            MOVLW   H'C8'                   ;ADRESSE 1 HOHE                 
            CALL    BEFEHL
            GOTO    VB2

WB2         MOVLW   H'C0'                   ;ADRESSE 1 NIEDRIGE                 
            CALL    BEFEHL
            GOTO    VB2

WA2         MOVLW   H'84'                   ;ADRESSE 1                  
            CALL    BEFEHL
VB2         MOVF    ANZ_H, W
            ANDLW   H'0F'
            ADDLW   H'30'
            MOVWF   VER
            MOVLW   0X30
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W009

            BSF     MINUS, BIT1
            MOVLW   0X20                    ;VORNULL AUSBLENDEN
            CALL    DATEN
            CLRF    VER
            BSF     VER, BIT7               ;MERKER FR NCHSTE NULL AUSBLENDEN
            GOTO    W010
            
W009        BSF     MERKE, BIT0              ;
            MOVF    VER, W
            CALL    DATEN


W010        BTFSS   IA, BIT0
            GOTO    WA3

            BTFSS   IA, BIT1
            GOTO    WB3

            MOVLW   H'CA'                   ;ADRESSE 3 HOHE
            CALL    BEFEHL
            GOTO    VB3

WB3         MOVLW   H'C2'                   ;ADRESSE 3 NIEDRIGE
            CALL    BEFEHL
            GOTO    VB3

WA3         MOVLW   H'86'                   ;ADRESSE 3
            CALL    BEFEHL
VB3         MOVF    ANZ_L, W
            ANDLW   H'0F'
            ADDLW   H'30'
            CALL    DATEN

            BTFSS   IA, BIT0
            GOTO    WA4

            BTFSS   IA, BIT1
            GOTO    WB4

            MOVLW   H'C9'                   ;ADRESSE 2 HOHE
            CALL    BEFEHL
            GOTO    VB4

WB4         MOVLW   H'C1'                   ;ADRESSE 2 NIEDRIGE
            CALL    BEFEHL
            GOTO    VB4

WA4         MOVLW   H'85'                   ;ADRESSE 2
            CALL    BEFEHL
VB4         SWAPF   ANZ_L, W
            ANDLW   H'0F'
            ADDLW   H'30'
            MOVWF   VER
            MOVLW   0X30
            SUBWF   VER, W
            BTFSS   STATUS, Z
            GOTO    W011
            BTFSC   MERKE, BIT0              ;
            GOTO    W011                     ;
            BSF     MINUS, BIT2
            BCF     MINUS, BIT1
            MOVLW   0X20                    ;VORNULL AUSBLENDEN
            CALL    DATEN
            GOTO    W112
            
W011        MOVF    VER, W
            CALL    DATEN

W112        BTFSS   MINUS, BIT0
            GOTO    W113
            BTFSS   MINUS, BIT2
            GOTO    W114

            BTFSS   IA, BIT0
            GOTO    WA5

            BTFSS   IA, BIT1
            GOTO    WB5

            MOVLW   H'C9'                   ;ADRESSE 2 HOHE
            CALL    BEFEHL
            GOTO    VB5

WB5         MOVLW   H'C1'                   ;ADRESSE 2 NIEDRIGE
            CALL    BEFEHL
            GOTO    VB5

WA5         MOVLW   H'85'                   ;ADRESSE 2
            CALL    BEFEHL
VB5         MOVLW   H'2D'
            CALL    DATEN

W114        BTFSS   MINUS, BIT1
            GOTO    W113

            BTFSS   IA, BIT0
            GOTO    WA6

            BTFSS   IA, BIT1
            GOTO    WB6

            MOVLW   H'C8'                   ;ADRESSE 1 HOHE
            CALL    BEFEHL
            GOTO    VB6

WB6         MOVLW   H'C0'                   ;ADRESSE 1 NIEDRIGE
            CALL    BEFEHL
            GOTO    VB6


WA6         MOVLW   H'84'                   ;ADRESSE 1                  
            CALL    BEFEHL
VB6         MOVLW   H'2D'
            CALL    DATEN           


W113        RETURN


;*****************************************************************************
;*                        UNTERPROGRAMM EMPFANGEN RX VON EINEM BYTE          *
;*                             ERGEBNIS STEHT AM SCHLUSS IN W                *
;*                              03.02.11                                     *
;*****************************************************************************
RX              MOVLW   D'8'                     ;8 BITS SOLLEN EMPFANGEN WERDEN  
                MOVWF   ZAE
 
                CLRF    HELP1

RXANF           TXRX_OUTPUT                     ;0SEC
;ZEITSCHLEIFE 4SEC
                MOVLW   D'3'                    ;T=4
                MOVWF   HELP2                   ;T=4
L511            NOP                             ;T=4
                DECFSZ  HELP2, F                ;T=4 BEI SPRUNG T=8 
                GOTO    L511                    ;T=8 
;GES.: (16T*3) * 0,0625SEC=3,0SEC + (16T*0,0625SEC)=3,0SEC+1,0SEC=4SEC
;ENDE ZEITSCHLEIFE 
                TXRX_INPUT                      

;ZEITSCHLEIFE 5SEC
                MOVLW   D'4'                    ;T=4
                MOVWF   HELP2                   ;T=4
L512            NOP                             ;T=4
                DECFSZ  HELP2, F                ;T=4 BEI SPRUNG T=8 
                GOTO    L512                    ;T=8 
;GES.: (16T*4) * 0,0625SEC=4SEC + (16T*0,0625SEC)=4SEC+1,0SEC=5SEC
;ENDE ZEITSCHLEIFE   

                BTFSS   PORTA, TXRX
                GOTO    W513
                BSF     HELP1, BIT7

W513            DECFSZ  ZAE, F
                GOTO    W514

;ZEITSCHLEIFE 48SEC
                MOVLW   D'47'                   ;T=4
                MOVWF   HELP2                   ;T=4
L613            NOP                             ;T=4
                DECFSZ  HELP2, F                ;T=4 BEI SPRUNG T=8 
                GOTO    L613                    ;T=8 
;GES.: (16T*47) * 0,0625SEC=47SEC + (16T*0,0625SEC)=47SEC+1,0SEC=48SEC
;ENDE ZEITSCHLEIFE 

                MOVF    HELP1, W
                RETURN

W514            BCF     STATUS, C
                RRF     HELP1, F

;ZEITSCHLEIFE 48SEC
                MOVLW   D'47'                   ;T=4
                MOVWF   HELP2                   ;T=4
L513            NOP                             ;T=4
                DECFSZ  HELP2, F                ;T=4 BEI SPRUNG T=8 
                GOTO    L513                    ;T=8 
;GES.: (16T*47) * 0,0625SEC=47SEC + (16T*0,0625SEC)=47SEC+1,0SEC=48SEC
;ENDE ZEITSCHLEIFE 

                GOTO    RXANF

;*****************************************************************************
;*                        UNTERPROGRAMM SENDEN TX VON EINEM BYTE             *
;*                              03.02.11                                     *
;*****************************************************************************
TX              MOVWF   HELP1

                MOVLW   D'8'                     ;8 BITS SOLLEN BERTRAGEN WERDEN  
                MOVWF   ZAE

TXANF           RRF     HELP1, F                 ;BIT0 RECHTS SCHIEBEN BERS CARRY-REGISTER
                BTFSC   STATUS, C                ;SEQUENZ AUSWHLEN FR LOW- UND HIGH-BIT
                GOTO    HIGHH

;FUER LOW SENDEN
LOOW            TXRX_OUTPUT                     ;0SEC
;ZEITSCHLEIFE 62SEC
                MOVLW   D'61'                   ;T=4
                MOVWF   HELP2                   ;T=4
L111            NOP                             ;T=4
                DECFSZ  HELP2, F                ;T=4 BEI SPRUNG T=8 
                GOTO    L111                    ;T=8 
;GES.: (16T*61) * 0,0625SEC=61,0SEC + (16T*0,0625SEC)=61,0SEC+1,0SEC=62SEC
;ENDE ZEITSCHLEIFE 
                TXRX_INPUT                      

;ZEITSCHLEIFE 10SEC
                MOVLW   D'9'                    ;T=4
                MOVWF   HELP2                   ;T=4
L112            NOP                             ;T=4
                DECFSZ  HELP2, F                ;T=4 BEI SPRUNG T=8 
                GOTO    L112                    ;T=8 
;GES.: (16T*9) * 0,0625SEC=9SEC + (16T*0,0625SEC)=9SEC+1,0SEC=10SEC
;ENDE ZEITSCHLEIFE   

                DECFSZ  ZAE, F                     
                GOTO    TXANF
                RETURN

;-------------------------
;FUER HIGH SENDEN
HIGHH           TXRX_OUTPUT
;ZEITSCHLEIFE 6SEC
                MOVLW   D'5'                    ;T=4
                MOVWF   HELP2                   ;T=4
L211            NOP                             ;T=4
                DECFSZ  HELP2, F                ;T=4 BEI SPRUNG T=8 
                GOTO    L211                    ;T=8 
;GES.: (16T*5) * 0,0625SEC=5,0SEC + (16T*0,0625SEC)=5,0SEC+1,0SEC=6,0SEC
;ENDE ZEITSCHLEIFE     
                TXRX_INPUT                      

;ZEITSCHLEIFE 66SEC
                MOVLW   D'65'                   ;T=4
                MOVWF   HELP2                   ;T=4
L212            NOP                             ;T=4
                DECFSZ  HELP2, F                ;T=4 BEI SPRUNG T=8 
                GOTO    L212                    ;T=8 
;GES.: (16T*65) * 0,0625SEC=65,0SEC + (16T*0,0625SEC)=65,0SEC+1,0SEC=66,0SEC
;ENDE ZEITSCHLEIFE    

                DECFSZ  ZAE, F                     
                GOTO    TXANF
                RETURN

;BEI DEN ZEITEN HATTE ICH SCHON VIEL PROBIERT 
;DIE SUMME IST JETZT IMMER 72SEC == BEI LOW 62SEC+10SEC=72SEC    UND    BEI HIGH 6SEC+66SEC=72SEC


;*****************************************************************************
;*                        UNTERPROGRAMM RESET                                *
;*                              03.02.11                                     *
;*****************************************************************************
RESE            TXRX_OUTPUT
;MINDESTENS 480SEC (GENOMMEN 485SEC) FUER LOW AN RA4 SENDEN
;ZEITSCHLEIFE 485SEC
                MOVLW   D'215'                  ;T=4
                MOVWF   HELP1                   ;T=4

LO1             NOP                             ;T=4
                NOP                             ;T=4
                NOP                             ;T=4
                NOP                             ;T=4
                NOP                             ;T=4
                NOP                             ;T=4
                DECFSZ  HELP1, F                ;T=4 BEI SPRUNG T=8 
                GOTO    LO1                     ;T=8 
;GES.: (36T*215) * 0,0625SEC=483,75SEC + (16T*0,0625SEC)=483,75SEC+1,0SEC=484,75SEC
;ENDE ZEITSCHLEIFE              
                TXRX_INPUT


;WARTEN 15-60SEC IST ES NOCH HIGH AN RA4(TXRX) , WARTEN BIS ES LOW WIRD
;WENN ES NICHT LOW WIRD,  KOMMT EIN ERNEUTER LOW-IMPULS NACH 5MSEC, ALSO SPRUNG ZUM ANFANG ZU RESET

;ZEITSCHLEIFEN-ABFRAGE 100SEC
                MOVLW   D'66'                   ;T=4
                MOVWF   HELP1                   ;T=4
L311            BTFSS   PORTA, TXRX             ;(T=4) BEI SPRUNG T=8
                GOTO    WARTE1
                NOP                             ;T=4
                DECFSZ  HELP1, F                ;T=4 BEI SPRUNG (T=8) 
                GOTO    L311                    ;T=8 
;GES.: (24T*66) * 0,0625SEC=99,0SEC + (16T*0,0625SEC)=99,0SEC+1,0SEC=100,0SEC
;ENDE ZEITSCHLEIFE    

;100SEC SIND ZU ENDE, ES KAM KEIN LOW-IMPULS, ES GEHT NACH 150MSEC ERNEUT ZUM RESET AM ANFANG
                CALL    SENSOR                  ;KEIN TEMP-SENSOR

                MOVLW   D'10'                   ;ZEITSCHLEIFE LADEN IN W MIT DEZIMAL 10 ALSO---> 10 * 100MSEC=1000MSEC=1SEC
                CALL    ZS100MS                 ;ZEITSCHLEIFE ABARBEITEN
                BCF     PORTB, NPN              ;RELAIS AUS
                BSF     NO_SENSOR, BIT0         ;MERKER DAS KEIN SENSOR ANGESCHLOSSEN WAR
                GOTO    RESE
                
;JETZT IST ES LOW (60 BIS 240SEC LANG) ALSO DER DS18S20 SENDET EIN LOW ZURCK
;WARTEN BIS ES HIGH WIRD
;ES WIRD NICHT KONTROLLIERT OB DER LOW-IMPULS NUN WIRKLICH ZWISCHEN 60 UND 240SEC LIEGT, ALSO KEINE LAENGEN-ZEIT-MESSUNG
WARTE1          BTFSS   PORTA, TXRX
                GOTO    WARTE1

;NACH MINDISTENS GESAMT 15SEC+60SEC+451SEC = HIER (526SEC)
;(SIEHE IM DATASHEET) KANN ES DANN WEITER GEHEN MIT DEM DATEN SENDEN IN DEN DS18S20 

;ZEITSCHLEIFE 451SEC
                MOVLW   D'200'                  ;T=4
                MOVWF   HELP1                   ;T=4

LO2             NOP                             ;T=4
                NOP                             ;T=4
                NOP                             ;T=4
                NOP                             ;T=4
                NOP                             ;T=4
                NOP                             ;T=4
                DECFSZ  HELP1, F                ;T=4 BEI SPRUNG T=8 
                GOTO    LO2                     ;T=8 
;GES.: (36T*200) * 0,0625SEC=450,0SEC + (16T*0,0625SEC)=450SEC+1,0SEC=451SEC
;ENDE ZEITSCHLEIFE 
;HIER GILT: DIE MIN. 15SEC + MIN. 60SEC = 75SEC +  X  = MUESSEN MIN. 480SEC SEIN /// HIER IST X=451SEC ALSO GESAMT:526SEC
;MIT X=451SEC IST ALSO ALLES OK

                RETURN

;*****************************************************************************
;*         UNTERPROGRAMM EIN                                                 *
;*                                                                           *
;*****************************************************************************
EIN         ;MOVLW   D'5'       ;0,5SEC ZEITSCHLEIFE WEGEN INDUKTIONSSPITZEN
            ;CALL    ZS100MS_EA  ;LCD-ANZEIGE SOLL NICHT HNGEN BLEIBEN !!!!!!!!!!!!!!!!!!!

            BSF PORTB, NPN

            MOVLW   D'5'       ;0,5SEC ZEITSCHLEIFE WEGEN INDUKTIONSSPITZEN
            CALL    ZS100MS_EA  ;LCD-ANZEIGE SOLL NICHT HNGEN BLEIBEN !!!!!!!!!!!!!!!!!!!

            BTFSC   NO_SENSOR, BIT3
            RETURN

            BSF     NO_SENSOR, BIT3 ;FLIP FLOP
            
            RETURN

;*****************************************************************************
;*         UNTERPROGRAMM AUS                                                 *
;*                                                                           *
;*****************************************************************************
AUS         ;MOVLW   D'5'       ;0,5SEC ZEITSCHLEIFE WEGEN INDUKTIONSSPITZEN
            ;CALL    ZS100MS_EA  ;LCD-ANZEIGE SOLL NICHT HNGEN BLEIBEN !!!!!!!!!!!!!!!!!!!

            BCF PORTB, NPN

            MOVLW   D'5'       ;0,5SEC ZEITSCHLEIFE WEGEN INDUKTIONSSPITZEN
            CALL    ZS100MS_EA  ;LCD-ANZEIGE SOLL NICHT HNGEN BLEIBEN !!!!!!!!!!!!!!!!!!!

            BTFSS   NO_SENSOR, BIT3
            RETURN

            BCF     NO_SENSOR, BIT3 ;FLIP FLOP
            BSF     NO_SENSOR, BIT7 ;START ZU MAIN
            RETURN

;*****************************************************************************
;*         UNTERPROGRAMM MIT TIMER0 ALS ZEITSCHLEIFE FUER  1MSEC ....        *
;*                                                                           *
;*****************************************************************************
ZS1MS                   MOVWF   HELP1                   ;DER INHALT VON W WIRD IN "HELP1" GELADEN

T01                     MOVLW   D'240'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 240 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
T02                     BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 10MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    T02                     ;ES ERFOLGT EIN SPRUNG ZU "DECFSC MERK, F"
                        
                        DECFSZ  HELP1, F                ;ES WIRD DER WERT IN "HELP1" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    T01                     ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS
                        RETURN

;ZEITBERECHNUNG FUER 1MS
;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.0625SEC=64SEC    /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;1MS : 64SEC= 15,6 GENOMMEN 16                                              /T = 1 : F  (F)-OSZILLATORFREQUENZ
;ALSO
;64S*D'16'=1,024MSEC
;TMR0 ALSO D'256'-D'16'=D'240' ENTSPRICHT CA. 1MS
;240 DEZIMAL OBEN EINTRAGEN

;*****************************************************************************
;*         UNTERPROGRAMM MIT TIMER0 ALS ZEITSCHLEIFE FUER  100MSEC ....      *
;*                                                                           *
;*****************************************************************************
ZS100MS                 MOVWF   HELP1                   ;DER INHALT VON W WIRD IN "HELP1" GELADEN

T100                    MOVLW   D'8'                    ;8MAL WIRD DIE 1MSEC ZEIT ABGEARBEITET, HIER WIRD GELADEN
                        MOVWF   HELP2                   ;ALSO 100MSEC

T101                    MOVLW   D'61'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 61 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
T102                    BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 12,5MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    T102                    ;ES ERFOLGT EIN SPRUNG ZU "DECFSC MERK, F"
                        
                        DECFSZ  HELP2, F
                        GOTO    T101

                        DECFSZ  HELP1, F                ;ES WIRD DER WERT IN "HELP1" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    T100                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        RETURN

;ZEITBERECHNUNG FUER 50MSEC
;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.0625SEC=64SEC    /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;12,5MSEC : 64SEC= 195,3 GENOMMEN 195                                      /T = 1 : F  (F)-OSZILLATORFREQUENZ
;ALSO
;64S*D'195'=12,5MSEC
;TMR0 ALSO D'256'-D'195'=D'61' ENTSPRICHT CA. 12,5MS
;61 DEZIMAL OBEN EINTRAGEN

;*****************************************************************************
;*         UNTERPROGRAMM MIT TIMER0 ALS ZEITSCHLEIFE FUER  100MSEC ....      *
;*                                                                           *
;*****************************************************************************
ZS100MS_EA              MOVWF   HELP1                   ;DER INHALT VON W WIRD IN "HELP1" GELADEN

TT100                   MOVLW   D'8'                    ;8MAL WIRD DIE 1MSEC ZEIT ABGEARBEITET, HIER WIRD GELADEN
                        MOVWF   HELP2                   ;ALSO 100MSEC

TT101                   MOVLW   D'61'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 61 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
;------------                        
TT102                   BTFSS   PORTA, AUF_H
                        RETURN
                        
                        BTFSS   PORTA, AB_H
                        RETURN
                        
                        BTFSS   PORTB, AUF_L
                        RETURN
                        
                        BTFSS   PORTB, AB_L
                        RETURN
;------------

                        BTFSS   INTCON, T0IF           ;WENN DIE ZEIT VON 12,5MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    T102                    ;ES ERFOLGT EIN SPRUNG ZU "DECFSC MERK, F"

                        DECFSZ  HELP2, F
                        GOTO    TT101

                        DECFSZ  HELP1, F                ;ES WIRD DER WERT IN "HELP1" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    TT100                   ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        RETURN

;*****************************************************************************
;*                              INIT TIMER1 125MSEC                          *
;*                                                                           *
;*****************************************************************************
        
I_ZS125MS   BCF     T1CON, TMR1ON       ;STOP TIMER1
            MOVLW   0X0B                
            MOVWF   TMR1H               
            MOVLW   0XDC
            MOVWF   TMR1L
            BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN
            BSF     T1CON, TMR1ON       ;START TIMER1
            RETURN


;TIMER1:
;32 * 0.0625SEC = 2SEC
;125MSEC : 2SEC = 62.500
;65536 (0X10000) - 62500 = 3036 IN HEX.0X0BDC
;BEI TMR1H 0X0B EINTRAGEN BERECHNET
;BEI TMR1L 0XDC EINTRAGEN BERECHNET


;*****************************************************************************
;*                              DATEN AUSGEBEN AUF DOT-LCD-MODUL             *
;*                              04.05.10                                     *
;*****************************************************************************
DATEN       BSF     PORTA, RS               ;ALS DATEN

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERK

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERK, W
            MOVWF   PORTB


            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    ;UNGEFAEHR 4SEC ZEITSCHLEIFE
            MOVWF   HELP1
D1          NOP                             ;T=4
            DECFSZ  HELP1, F                ;T=4
            GOTO    D1                      ;T=8    GES.:16TAKTE * 0,0625SEC= 1SEC    *4 DURCHLAEUFE= 4SEC
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;---------------------------------

;LOW 4BIT AUSGEBEN
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERK

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERK, W
            MOVWF   PORTB


            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    
            MOVWF   HELP1
DDD1        NOP                             
            DECFSZ  HELP1, F                
            GOTO    DDD1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;ZEITSCHLEIFE 40SEC
            MOVLW   D'40'                   ;UNGEFAEHR 40SEC ZEITSCHLEIFE SIEHE OBEN
            MOVWF   HELP1
DDDD1       NOP
            DECFSZ  HELP1, F                
            GOTO    DDDD1
;ENDE ZEITSCHLEIFE



            RETURN

;*****************************************************************************
;*                              BEFEHL AUSGEBEN AUF DOT-LCD-MODUL            *
;*                              04.05.10                                     *
;*****************************************************************************
BEFEHL      BCF     PORTA, RS                ;ALS BEFEHL

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERK

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERK, W
            MOVWF   PORTB

            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    ;UNGEFAEHR 8SEC ZEITSCHLEIFE
            MOVWF   HELP1
B1          NOP                             
            DECFSZ  HELP1, F               
            GOTO    B1                      
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;---------------------------------

;LOW 4BIT AUSGEBEN
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERK

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERK, W
            MOVWF   PORTB

            BSF     PORTA, EN

;ZEITSCHLEIFE 4SEC
            MOVLW   D'4'                    
            MOVWF   HELP1
BBB1        NOP                             
            DECFSZ  HELP1, F                
            GOTO    BBB1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTA, EN

;ZEITSCHLEIFE 40SEC
            MOVLW   D'40'                   ;UNGEFAEHR 40SEC ZEITSCHLEIFE
            MOVWF   HELP1
BBBB1       NOP
            DECFSZ  HELP1, F                ;WIE GANZ OBEN 
            GOTO    BBBB1
;ENDE ZEITSCHLEIFE
 
            RETURN

;*****************************************************************************
;*                              TEXT "EIN"                                   *
;*                                                                           *
;*****************************************************************************
EI          MOVLW   H'8C' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8D' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'8E' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'8F' 
            CALL    BEFEHL
            MOVLW   "N"
            CALL    DATEN

            RETURN 


;*****************************************************************************
;*                              TEXT "AUS"                                   *
;*                                                                           *
;*****************************************************************************
AU          MOVLW   H'8C' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8D' 
            CALL    BEFEHL
            MOVLW   "A"
            CALL    DATEN

            MOVLW   H'8E' 
            CALL    BEFEHL
            MOVLW   "U"
            CALL    DATEN

            MOVLW   H'8F' 
            CALL    BEFEHL
            MOVLW   "S"
            CALL    DATEN

            RETURN 

;*****************************************************************************
;*                              TEXT "ST" STELLEN                            *
;*                                                                           *
;*****************************************************************************
ST          MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   "N"
            CALL    DATEN

            MOVLW   H'86' 
            CALL    BEFEHL
            MOVLW   "S"
            CALL    DATEN

            MOVLW   H'87' 
            CALL    BEFEHL
            MOVLW   "T"
            CALL    DATEN

            MOVLW   H'88' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'89' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'8A' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'8B' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'8C' 
            CALL    BEFEHL
            MOVLW   "N"
            CALL    DATEN

            MOVLW   H'8D' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8E' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8F' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            RETURN 

;*****************************************************************************
;*                              TEXT "LEER"                                  *
;*                                                                           *
;*****************************************************************************
LE          MOVLW   H'8C' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8D' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8E' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8F' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            RETURN 

;*****************************************************************************
;*                              TEXT "IST C , "                             *
;*                                                                           *
;*****************************************************************************
IS          MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "S"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "T"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'86' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'87' 
            CALL    BEFEHL
            MOVLW   "."
            CALL    DATEN

            MOVLW   H'88' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'89' 
            CALL    BEFEHL
            MOVLW   B'11011111'
            CALL    DATEN

            MOVLW   H'8A' 
            CALL    BEFEHL
            MOVLW   "C"
            CALL    DATEN

            MOVLW   H'8B' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            RETURN

;*****************************************************************************
;*                              TEXT " / C , ,"                             *
;*                                                                           *
;*****************************************************************************
GR          MOVLW   H'C0' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C1' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C2' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C3' 
            CALL    BEFEHL
            MOVLW   "."
            CALL    DATEN

            MOVLW   H'C4' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN


            MOVLW   H'C5' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C6' 
            CALL    BEFEHL
            MOVLW   "/"
            CALL    DATEN

            MOVLW   H'C7' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN


            MOVLW   H'C8' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN


            MOVLW   H'C9' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN


            MOVLW   H'CA' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CB' 
            CALL    BEFEHL
            MOVLW   "."
            CALL    DATEN

            MOVLW   H'CC' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN


            MOVLW   H'CD' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CE' 
            CALL    BEFEHL
            MOVLW   B'11011111'
            CALL    DATEN

            MOVLW   H'CF' 
            CALL    BEFEHL
            MOVLW   "C"
            CALL    DATEN

            RETURN

;*****************************************************************************
;*                              TEXT "PRINZIP"                               *
;*                                                                           *
;*****************************************************************************
PRINZIP     MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   "P"
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   "R"
            CALL    DATEN

            MOVLW   H'86' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'87' 
            CALL    BEFEHL
            MOVLW   "N"
            CALL    DATEN

            MOVLW   H'88' 
            CALL    BEFEHL
            MOVLW   "Z"
            CALL    DATEN

            MOVLW   H'89' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'8A' 
            CALL    BEFEHL
            MOVLW   "P"
            CALL    DATEN

            MOVLW   H'8B' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8C' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8D' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8E' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8F' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            RETURN

;*****************************************************************************
;*                              TEXT "KHLEN"                                *
;*                                                                           *
;*****************************************************************************
KUEL        MOVLW   H'C0' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C1' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C2' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C3' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C4' 
            CALL    BEFEHL
            MOVLW   "K"
            CALL    DATEN

            MOVLW   H'C5' 
            CALL    BEFEHL
            MOVLW   "U"
            CALL    DATEN

            MOVLW   H'C6' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'C7' 
            CALL    BEFEHL
            MOVLW   "H"
            CALL    DATEN

            MOVLW   H'C8' 
            CALL    BEFEHL
            MOVLW   "L"
            CALL    DATEN

            MOVLW   H'C9' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'CA' 
            CALL    BEFEHL
            MOVLW   "N"
            CALL    DATEN

            MOVLW   H'CB' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CC' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CD' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CE' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CF' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            RETURN

;*****************************************************************************
;*                              TEXT "HEIZEN"                                *
;*                                                                           *
;*****************************************************************************
HEIZ        MOVLW   H'C0' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C1' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C2' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C3' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'C4' 
            CALL    BEFEHL
            MOVLW   "H"
            CALL    DATEN

            MOVLW   H'C5' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'C6' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'C7' 
            CALL    BEFEHL
            MOVLW   "Z"
            CALL    DATEN

            MOVLW   H'C8' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'C9' 
            CALL    BEFEHL
            MOVLW   "N"
            CALL    DATEN

            MOVLW   H'CA' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CB' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CC' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CD' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CE' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'CF' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            RETURN



;*****************************************************************************
;*                              TEXT "KEIN TEMP-SENSOR "                     *
;*                                                                           *
;*****************************************************************************
SENSOR      MOVLW   H'80' 
            CALL    BEFEHL
            MOVLW   "K"
            CALL    DATEN

            MOVLW   H'81' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'82' 
            CALL    BEFEHL
            MOVLW   "I"
            CALL    DATEN

            MOVLW   H'83' 
            CALL    BEFEHL
            MOVLW   "N"
            CALL    DATEN

            MOVLW   H'84' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'85' 
            CALL    BEFEHL
            MOVLW   "S"
            CALL    DATEN

            MOVLW   H'86' 
            CALL    BEFEHL
            MOVLW   "E"
            CALL    DATEN

            MOVLW   H'87' 
            CALL    BEFEHL
            MOVLW   "N"
            CALL    DATEN

            MOVLW   H'88' 
            CALL    BEFEHL
            MOVLW   "S"
            CALL    DATEN

            MOVLW   H'89' 
            CALL    BEFEHL
            MOVLW   "O"
            CALL    DATEN

            MOVLW   H'8A' 
            CALL    BEFEHL
            MOVLW   "R"
            CALL    DATEN

            MOVLW   H'8B' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8C' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8D' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8E' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            MOVLW   H'8F' 
            CALL    BEFEHL
            MOVLW   " "
            CALL    DATEN

            RETURN


;-----------------
            END









